Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 858)
@@ -17,5 +17,6 @@
    USE sms             ! 
    USE p4zday          !
-   
+   USE prtctl_trc
+
    IMPLICIT NONE
    PRIVATE
@@ -23,4 +24,5 @@
    PUBLIC   p4z_prod    ! called in p4zbio.F90
 
+   
    !!* Substitution
 #  include "domzgr_substitute.h90"
@@ -33,5 +35,5 @@
 CONTAINS
 
-   SUBROUTINE p4z_prod
+   SUBROUTINE p4z_prod( kt )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE p4z_prod  ***
@@ -42,15 +44,36 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zsilfac, zfact
+      INTEGER, INTENT(in) :: kt
+      INTEGER  ::   ji, jj, jk, nspyr
+      REAL(wp) ::   zsilfac, zfact, zrfact2
       REAL(wp) ::   zprdiachl, zprbiochl, zsilim, ztn, zadap, zadap2
-      REAL(wp) ::   zlim, zsilfac2, zsiborn, zprod
-      REAL(wp) ::   zmxltst, zmxlday, zlim1
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zmixnano , zmixdiat
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpislopen, zpislope2n
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsopt    , zpislopead
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprdia   , zprbio
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zetot2   , zpislopead2
+      REAL(wp) ::   zlim, zsilfac2, zsiborn, zprod, zetot2, zmax, zproreg, zproreg2
+      REAL(wp) ::   zmxltst, zmxlday, zlim1, zexcret, zexcret2
+      REAL(wp) ::   zpislopen  , zpislope2n
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zmixnano   , zmixdiat
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpislopead , zpislopead2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprdia     , zprbio, zysopt
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprorca    , zprorca2, zprorca4
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprorca5   , zprorca6, zprorca7
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpronew    , zpronew2
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+      zprorca (:,:,:) = 0.0
+      zprorca2(:,:,:) = 0.0
+      zprorca4(:,:,:) = 0.0
+      zprorca5(:,:,:) = 0.0
+      zprorca6(:,:,:) = 0.0
+      zprorca7(:,:,:) = 0.0
+      zpronew (:,:,:) = 0.0
+      zpronew2(:,:,:) = 0.0
+      zprdia  (:,:,:) = 0.0
+      zprbio  (:,:,:) = 0.0
+      zysopt  (:,:,:) = 0.0
+
+      nspyr  = INT( raass / rdt )
+
+      zexcret  = 1. - excret
+      zexcret2 = 1. - excret2
 
 !     Computation of the optimal production
@@ -65,51 +88,49 @@
       CALL p4z_day       ! Computation of the day length
 
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
+!CDIR NOVERRCHK
+      DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
             DO ji = 1, jpi
 
 !      Computation of the P-I slope for nanos and diatoms
 !      --------------------------------------------------
-
-               ztn    = MAX( 0., tn(ji,jj,jk) - 15. )
-               zadap  = 1.+ 2.* ztn / ( 2.+ ztn )
-               zadap2 = 1.e0
-
-               zfact  = EXP( -0.21 * emoy(ji,jj,jk) )
-
-               zpislopead (ji,jj,jk) = pislope  * ( 1.+ zadap  * zfact )
-               zpislopead2(ji,jj,jk) = pislope2 * ( 1.+ zadap2 * zfact )
-
-               zpislopen(ji,jj,jk) = zpislopead(ji,jj,jk) * trn(ji,jj,jk,jpnch)               &
-                  &                / ( trn(ji,jj,jk,jpphy) * 12.                   + rtrn )   &
-                  &                / ( prmax(ji,jj,jk) * rjjss * xlimphy(ji,jj,jk) + rtrn )
-
-               zpislope2n(ji,jj,jk) = zpislopead2(ji,jj,jk) * trn(ji,jj,jk,jpdch)              &
-                  &                 / ( trn(ji,jj,jk,jpdia) * 12.                   + rtrn )   &
-                  &                 / ( prmax(ji,jj,jk) * rjjss * xlimdia(ji,jj,jk) + rtrn )
-
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
+                IF( etot(ji,jj,jk) > 1.E-3 ) THEN
+                   ztn    = MAX( 0., tn(ji,jj,jk) - 15. )
+                   zadap  = 0.+ 1.* ztn / ( 2.+ ztn )
+                   zadap2 = 0.e0
+
+                   zfact  = EXP( -0.21 * emoy(ji,jj,jk) )
+
+                   zpislopead (ji,jj,jk) = pislope  * ( 1.+ zadap  * zfact )
+                   zpislopead2(ji,jj,jk) = pislope2 * ( 1.+ zadap2 * zfact )
+
+                   zpislopen = zpislopead(ji,jj,jk) * trn(ji,jj,jk,jpnch)               &
+                     &         / ( trn(ji,jj,jk,jpphy) * 12.                   + rtrn )   &
+                     &         / ( prmax(ji,jj,jk) * rjjss * xlimphy(ji,jj,jk) + rtrn )
+
+                   zpislope2n = zpislopead2(ji,jj,jk) * trn(ji,jj,jk,jpdch)              &
+                     &          / ( trn(ji,jj,jk,jpdia) * 12.                   + rtrn )   &
+                     &          / ( prmax(ji,jj,jk) * rjjss * xlimdia(ji,jj,jk) + rtrn )
 
 !     Computation of production function
 !     ----------------------------------
 
-               zprbio(ji,jj,jk) = prmax(ji,jj,jk) * (  1.- EXP( -zpislopen (ji,jj,jk) * etot(ji,jj,jk) )  )
-               zprdia(ji,jj,jk) = prmax(ji,jj,jk) * (  1.- EXP( -zpislope2n(ji,jj,jk) * etot(ji,jj,jk) )  )
-
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
+                   zprbio(ji,jj,jk) = prmax(ji,jj,jk) * &
+                     &                (  1.- EXP( -zpislopen * enano(ji,jj,jk) )  )
+                   zprdia(ji,jj,jk) = prmax(ji,jj,jk) * &
+                     &                (  1.- EXP( -zpislope2n * ediat(ji,jj,jk) )  )
+               ENDIF
+            END DO
+         END DO
+      END DO
+
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+
+                IF( etot(ji,jj,jk) > 1.E-3 ) THEN
 !    Si/C of diatoms
 !    ------------------------
@@ -118,18 +139,18 @@
 !    to mimic the very high ratios observed in the Southern Ocean (silpot2)
 
-               zlim1  = trn(ji,jj,jk,jpsil) / ( trn(ji,jj,jk,jpsil) + xksi1 )
-               zlim   = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
-
-               zsilim = MIN( zprdia(ji,jj,jk)    / ( rtrn + prmax(ji,jj,jk) ),                    &
+                  zlim1  = trn(ji,jj,jk,jpsil) / ( trn(ji,jj,jk,jpsil) + xksi1 )
+                  zlim   = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
+
+                  zsilim = MIN( zprdia(ji,jj,jk)    / ( rtrn + prmax(ji,jj,jk) ),                    &
                   &          trn(ji,jj,jk,jpfer) / ( concdfe(ji,jj,jk) + trn(ji,jj,jk,jpfer) ),   &
                   &          trn(ji,jj,jk,jppo4) / ( concdnh4 + trn(ji,jj,jk,jppo4) ),            &
                   &          zlim )
-               zsilfac = 5.4 * EXP( -4.23 * zsilim ) * MAX( 0.e0, MIN( 1., 2.2 * ( zlim1 - 0.5 ) )  ) + 1.e0
-               zsiborn = MAX( 0.e0, ( trn(ji,jj,jk,jpsil) - 15.e-6 ) )
-               zsilfac2 = 1.+ 3.* zsiborn / ( zsiborn + xksi2 )
-               zsilfac = MIN( 6.4,zsilfac * zsilfac2)
-
-               zsopt(ji,jj,jk) = grosip * trn(ji,jj,jk,jpsil) / ( trn(ji,jj,jk,jpsil) + xksi1 ) * zsilfac
-
+                  zsilfac = 5.4 * EXP( -4.23 * zsilim ) * MAX( 0.e0, MIN( 1., 2.2 * ( zlim1 - 0.5 ) )  ) + 1.e0
+                  zsiborn = MAX( 0.e0, ( trn(ji,jj,jk,jpsil) - 15.e-6 ) )
+                  zsilfac2 = 1.+ 3.* zsiborn / ( zsiborn + xksi2 )
+                  zsilfac = MIN( 6.4,zsilfac * zsilfac2)
+                  zysopt(ji,jj,jk) = grosip * zlim1 * zsilfac
+
+              ENDIF
             END DO
          END DO
@@ -142,5 +163,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            zmxltst = MAX( 0.e0, hmld(ji,jj) - zmeu(ji,jj) )
+            zmxltst = MAX( 0.e0, hmld(ji,jj) - heup(ji,jj) )
             zmxlday = zmxltst**2 / rjjss
             zmixnano(ji,jj) = 1.- zmxlday / ( 1.+ zmxlday )
@@ -163,79 +184,157 @@
       END DO
 
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
 
 !      Computation of the maximum light intensity
 !      ------------------------------------------
-               zetot2(ji,jj,jk) = etot(ji,jj,jk) * 24. / ( strn(ji,jj) + rtrn )
-               IF( strn(ji,jj) < 1.e0 )   zetot2(ji,jj,jk) = etot(ji,jj,jk)
-
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
+            IF( strn(ji,jj) < 1.e0 )   strn(ji,jj) = 24.
+         END DO
+      END DO
+
+!CDIR NOVERRCHK
+      DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
+            DO ji = 1, jpi
+
+               IF( etot(ji,jj,jk) > 1.E-3 ) THEN
 !     Computation of the various production terms for nanophyto.
 !     ----------------------------------------------------------
-               zpislopen(ji,jj,jk) = zpislopead(ji,jj,jk)          &
-                  &                * trn(ji,jj,jk,jpnch) / ( rtrn + trn(ji,jj,jk,jpphy) * 12.)         &
-                  &                / ( prmax(ji,jj,jk) * rjjss * MAX( 0.1, xlimphy(ji,jj,jk) ) + rtrn )
-
-               zprbiochl = prmax(ji,jj,jk) * (  1.- EXP( -zpislopen(ji,jj,jk) * zetot2(ji,jj,jk) )  )
-
-               prorca(ji,jj,jk) = zprbio(ji,jj,jk)  * xlimphy(ji,jj,jk) * trn(ji,jj,jk,jpphy) * rfact2
-
-               pronew(ji,jj,jk) = prorca(ji,jj,jk) * xnanono3(ji,jj,jk)    &
+                  zetot2 = enano(ji,jj,jk) * 24. / ( strn(ji,jj) + rtrn )
+                  zmax = MAX( 0.1, xlimphy(ji,jj,jk) )
+                  zpislopen = zpislopead(ji,jj,jk)          &
+                  &         * trn(ji,jj,jk,jpnch) / ( rtrn + trn(ji,jj,jk,jpphy) * 12.)         &
+                  &         / ( prmax(ji,jj,jk) * rjjss * zmax + rtrn )
+
+                  zprbiochl = prmax(ji,jj,jk) * (  1.- EXP( -zpislopen * zetot2 )  )
+
+                  zprorca(ji,jj,jk) = zprbio(ji,jj,jk)  * xlimphy(ji,jj,jk) * trn(ji,jj,jk,jpphy) * rfact2
+
+                  zpronew(ji,jj,jk) = zprorca(ji,jj,jk) * xnanono3(ji,jj,jk)    &
                   &             / ( xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk) + rtrn )
-               proreg(ji,jj,jk) = prorca(ji,jj,jk) - pronew(ji,jj,jk)
-
-               zprod = rjjss * prorca(ji,jj,jk) * zprbiochl * trn(ji,jj,jk,jpphy)   &
-                  &                             * MAX( 0.1, xlimphy(ji,jj,jk) )
-
-               prorca5(ji,jj,jk) = (fecnm)**2 * zprod / chlcnm            &
-                  &              / (  zpislopead(ji,jj,jk) * zetot2(ji,jj,jk) * trn(ji,jj,jk,jpnfe) + rtrn  )
-
-               prorca6(ji,jj,jk) = chlcnm * 144. * zprod                  &
-                  &              / (  zpislopead(ji,jj,jk) * zetot2(ji,jj,jk) * trn(ji,jj,jk,jpnch) + rtrn  )
-
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
+                  zprod = rjjss * zprorca(ji,jj,jk) * zprbiochl * trn(ji,jj,jk,jpphy) *zmax
+
+                  zprorca5(ji,jj,jk) = (fecnm)**2 * zprod / chlcnm            &
+                  &              / (  zpislopead(ji,jj,jk) * zetot2 * trn(ji,jj,jk,jpnfe) + rtrn  )
+
+                  zprorca6(ji,jj,jk) = chlcnm * 144. * zprod                  &
+                  &              / (  zpislopead(ji,jj,jk) * zetot2 * trn(ji,jj,jk,jpnch) + rtrn  )
+               ENDIF
+            END DO
+         END DO
+      END DO
+
+!CDIR NOVERRCHK
+      DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
+            DO ji = 1, jpi
+               IF( etot(ji,jj,jk) > 1.E-3 ) THEN
 !       Computation of the various production terms for diatoms
 !       -------------------------------------------------------
-               zpislope2n(ji,jj,jk) = zpislopead2(ji,jj,jk) * trn(ji,jj,jk,jpdch)        &
-                  &                 / ( rtrn + trn(ji,jj,jk,jpdia) * 12.)        &
-                  &                 / ( prmax(ji,jj,jk) * rjjss * MAX( 0.1, xlimdia(ji,jj,jk) ) + rtrn )
-
-               zprdiachl = prmax(ji,jj,jk) * (  1.- EXP( -zetot2(ji,jj,jk) * zpislope2n(ji,jj,jk) )  )
-
-               prorca2(ji,jj,jk) = zprdia(ji,jj,jk) * xlimdia(ji,jj,jk) * trn(ji,jj,jk,jpdia) * rfact2
-
-               pronew2(ji,jj,jk) = prorca2(ji,jj,jk) * xdiatno3(ji,jj,jk)     &
+                  zetot2 = ediat(ji,jj,jk) * 24. / ( strn(ji,jj) + rtrn )
+                  zmax = MAX( 0.1, xlimdia(ji,jj,jk) )
+                  zpislope2n = zpislopead2(ji,jj,jk) * trn(ji,jj,jk,jpdch)        &
+                  &           / ( rtrn + trn(ji,jj,jk,jpdia) * 12.)        &
+                  &           / ( prmax(ji,jj,jk) * rjjss * zmax + rtrn )
+
+                  zprdiachl = prmax(ji,jj,jk) * (  1.- EXP( -zetot2 * zpislope2n )  )
+
+                  zprorca2(ji,jj,jk) = zprdia(ji,jj,jk) * xlimdia(ji,jj,jk) * trn(ji,jj,jk,jpdia) * rfact2
+
+                  zpronew2(ji,jj,jk) = zprorca2(ji,jj,jk) * xdiatno3(ji,jj,jk)     &
                   &              / ( xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk) + rtrn )
-               proreg2(ji,jj,jk) = prorca2(ji,jj,jk) - pronew2(ji,jj,jk)
-               prorca3(ji,jj,jk) = prorca2(ji,jj,jk) * zsopt(ji,jj,jk)
-
-               zprod=rjjss * prorca2(ji,jj,jk) * zprdiachl * trn(ji,jj,jk,jpdia) * MAX( 0.1, xlimdia(ji,jj,jk) )
-
-               prorca4(ji,jj,jk) = (fecdm)**2 * zprod / chlcdm                   &
-                  &              / ( zpislopead2(ji,jj,jk) * zetot2(ji,jj,jk) * trn(ji,jj,jk,jpdfe) + rtrn )
-
-               prorca7(ji,jj,jk) = chlcdm * 144. * zprod       &
-                  &              / ( zpislopead2(ji,jj,jk) * zetot2(ji,jj,jk) * trn(ji,jj,jk,jpdch) + rtrn )
-
+
+                  zprod = rjjss * zprorca2(ji,jj,jk) * zprdiachl * trn(ji,jj,jk,jpdia) * zmax
+
+                  zprorca4(ji,jj,jk) = (fecdm)**2 * zprod / chlcdm                   &
+                  &              / ( zpislopead2(ji,jj,jk) * zetot2 * trn(ji,jj,jk,jpdfe) + rtrn )
+
+                  zprorca7(ji,jj,jk) = chlcdm * 144. * zprod       &
+                  &              / ( zpislopead2(ji,jj,jk) * zetot2 * trn(ji,jj,jk,jpdch) + rtrn )
+
+               ENDIF
             END DO
          END DO
       END DO
       !
+
+!
+!   Update the arrays TRA which contain the biological sources and sinks
+!   --------------------------------------------------------------------
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+           DO ji =1 ,jpi
+              zproreg  = zprorca(ji,jj,jk) - zpronew(ji,jj,jk)
+              zproreg2 = zprorca2(ji,jj,jk) - zpronew2(ji,jj,jk)
+              tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) - zprorca(ji,jj,jk) - zprorca2(ji,jj,jk)
+              tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) - zpronew(ji,jj,jk) - zpronew2(ji,jj,jk)
+              tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) - zproreg - zproreg2
+              tra(ji,jj,jk,jpphy) = tra(ji,jj,jk,jpphy) + zprorca(ji,jj,jk) * zexcret
+              tra(ji,jj,jk,jpnch) = tra(ji,jj,jk,jpnch) + zprorca6(ji,jj,jk) * zexcret
+              tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) + zprorca5(ji,jj,jk) * zexcret
+              tra(ji,jj,jk,jpdia) = tra(ji,jj,jk,jpdia) + zprorca2(ji,jj,jk) * zexcret2
+              tra(ji,jj,jk,jpdch) = tra(ji,jj,jk,jpdch) + zprorca7(ji,jj,jk) * zexcret2
+              tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) + zprorca4(ji,jj,jk) * zexcret2
+              tra(ji,jj,jk,jpbsi) = tra(ji,jj,jk,jpbsi) + zprorca2(ji,jj,jk) * zysopt(ji,jj,jk) * zexcret2
+              tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + &
+              &                     excret2 * zprorca2(ji,jj,jk) + excret * zprorca(ji,jj,jk)
+              tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) + o2ut * ( zproreg + zproreg2) &
+              &                    + ( o2ut + o2nit ) * ( zpronew(ji,jj,jk) + zpronew2(ji,jj,jk) )
+              tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) &
+              &                     - zexcret * zprorca5(ji,jj,jk) - zexcret2 * zprorca4(ji,jj,jk)
+              tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) &
+              &                     - zexcret2 * zprorca2(ji,jj,jk) * zysopt(ji,jj,jk)
+              tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprorca(ji,jj,jk) - zprorca2(ji,jj,jk)
+              tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) &
+              &                    + rno3 * ( zpronew(ji,jj,jk) + zpronew2(ji,jj,jk) )
+          END DO
+        END DO
+     END DO
+
+
+     DO jk = 1, jpkm1
+        DO jj = 1, jpj
+          DO ji = 1, jpi
+             qcumul(2) = qcumul(2) + ( zprorca(ji,jj,jk) + zprorca2(ji,jj,jk) )  &
+             &                       * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) * tmask_i(ji,jj)
+          END DO
+        END DO
+      END DO
+
+      IF( MOD( kt, nspyr ) == 0 ) THEN
+        WRITE(numout,*) 'Total PP :'
+        WRITE(numout,*) '-------------------- : ',qcumul(2)*12./1E12
+        WRITE(numout,*) '(GtC/an)'
+        qcumul(2) = 0.
+      ENDIF
+
+#if defined key_trc_dia3d
+      zrfact2 = 1.e3 * rfact2r
+!   Supplementary diagnostics
+!   -------------------------
+      trc3d(:,:,:,4)  = etot(:,:,:)
+      trc3d(:,:,:,5)  = zprorca(:,:,:)  * zrfact2
+      trc3d(:,:,:,6)  = zprorca2(:,:,:) * zrfact2
+      trc3d(:,:,:,7)  = zpronew(:,:,:)  * zrfact2
+      trc3d(:,:,:,8)  = zpronew2(:,:,:) * zrfact2
+      trc3d(:,:,:,9)  = zprorca2(:,:,:) * zysopt(:,:,:) * zrfact2
+      trc3d(:,:,:,10) = zprorca4(:,:,:) * zrfact2
+#if ! defined key_kriest
+      trc3d(:,:,:,11) = zprorca5(:,:,:) * zrfact2
+#endif
+#endif
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('prod')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_prod
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 858)
@@ -17,4 +17,5 @@
    USE trp_trc         ! 
    USE sms             ! 
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -45,7 +46,11 @@
       REAL(wp) ::   zkeq  , zfeequi, zsiremin
       REAL(wp) ::   zsatur, zsatur2, znusil
-      REAL(wp) ::   zlamfac, zstep
+      REAL(wp) ::   zbactfer, zorem, zorem2, zofer, zofer2
+      REAL(wp) ::   zosil, zdenom, zdenom1, zdenom2, zscave, zaggdfe
+      REAL(wp) ::   zlamfac, zstep, zonitr
       REAL(wp), DIMENSION(jpi,jpj)     ::   ztempbac
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepbac, zfesatur
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepbac, zfesatur, zolimi
+      CHARACTER (len=25) :: charout
+
       !!---------------------------------------------------------------------
 
@@ -85,4 +90,5 @@
       nitrfac(:,:,:) = MIN( 1., nitrfac(:,:,:) )
 
+
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -102,10 +108,10 @@
 !     Ammonification in oxic waters with oxygen consumption
 !     -----------------------------------------------------
-               olimi(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpoxy) - rtrn ) / o2ut,                     &
+               zolimi(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpoxy) - rtrn ) / o2ut,  &
                   &                    zremik * ( 1.- nitrfac(ji,jj,jk) ) * trn(ji,jj,jk,jpdoc)  ) 
 
 !     Ammonification in suboxic waters with denitrification
 !     -------------------------------------------------------
-               denitr(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpno3) - rtrn ) / rdenit,           &
+               denitr(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpno3) - rtrn ) / rdenit,   &
                   &                     zremik * nitrfac(ji,jj,jk) * trn(ji,jj,jk,jpdoc)  )
             END DO
@@ -113,6 +119,6 @@
       END DO
 
-      olimi (:,:,:) = MAX( 0.e0, olimi (:,:,:) )
-      denitr(:,:,:) = MAX( 0.e0, denitr(:,:,:) )
+      zolimi (:,:,:) = MAX( 0.e0, zolimi (:,:,:) )
+      denitr (:,:,:) = MAX( 0.e0, denitr (:,:,:) )
 
       DO jk = 1, jpkm1
@@ -123,12 +129,28 @@
 !    below 2 umol/L. Inhibited at strong light 
 !    ----------------------------------------------------------
-               onitr(ji,jj,jk) = nitrif * zstep * trn(ji,jj,jk,jpnh4) / ( 1.+ emoy(ji,jj,jk) )     &
-# if defined key_off_degrad
-                  &            * facvol(ji,jj,jk)              &
-# endif
-                  &            * ( 1.- nitrfac(ji,jj,jk) )
-            END DO
-         END DO
-      END DO
+               zonitr  = nitrif * zstep * trn(ji,jj,jk,jpnh4) / ( 1.+ emoy(ji,jj,jk) )     &
+# if defined key_off_degrad
+                  &      * facvol(ji,jj,jk)              &
+# endif
+                  &      * ( 1.- nitrfac(ji,jj,jk) )
+
+!
+!   Update of the tracers trends
+!   ----------------------------
+
+              tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) - zonitr
+              tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) + zonitr
+              tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2nit * zonitr
+              tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - rno3  * zonitr
+
+            END DO
+         END DO
+      END DO
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem1')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
 
       DO jk = 1, jpkm1
@@ -141,12 +163,25 @@
 !    significant
 !    ----------------------------------------------------------
-               xbactfer(ji,jj,jk) = 15.e-6 * rfact2 * 4.* 0.4 * prmax(ji,jj,jk)           &
+               zbactfer = 15.e-6 * rfact2 * 4.* 0.4 * prmax(ji,jj,jk)           &
                   &               * ( xlimphy(ji,jj,jk) * zdepbac(ji,jj,jk))**2           &
                   &                  / ( xkgraz2 + zdepbac(ji,jj,jk) )                    &
                   &                  * ( 0.5 + SIGN( 0.5, trn(ji,jj,jk,jpfer) -2.e-11 )  )
 
-            END DO
-         END DO
-      END DO
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zbactfer
+#if defined key_kriest
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zbactfer
+#else
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zbactfer
+#endif
+
+            END DO
+         END DO
+      END DO
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem2')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
 
       DO jk = 1, jpkm1
@@ -167,15 +202,38 @@
 !    means a disaggregation constant about 0.5 the value in oxic zones
 !    -----------------------------------------------------------------
-               orem (ji,jj,jk) = zremip * trn(ji,jj,jk,jppoc)
-               ofer (ji,jj,jk) = zremip * trn(ji,jj,jk,jpsfe)
+               zorem  = zremip * trn(ji,jj,jk,jppoc)
+               zofer  = zremip * trn(ji,jj,jk,jpsfe)
 #if ! defined key_kriest
-               orem2(ji,jj,jk) = zremip * trn(ji,jj,jk,jpgoc)
-               ofer2(ji,jj,jk) = zremip * trn(ji,jj,jk,jpbfe)
-#else
-               orem2(ji,jj,jk) = zremip * trn(ji,jj,jk,jpnum)
-#endif
-            END DO
-         END DO
-      END DO
+               zorem2 = zremip * trn(ji,jj,jk,jpgoc)
+               zofer2 = zremip * trn(ji,jj,jk,jpbfe)
+#else
+               zorem2 = zremip * trn(ji,jj,jk,jpnum)
+#endif
+
+!  Update the appropriate tracers trends
+!  -------------------------------------
+
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zorem
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer
+#if defined key_kriest
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zorem
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) - zorem2
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
+#else
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem2 - zorem
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) - zorem2
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zofer2 - zofer
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) - zofer2
+#endif
+
+            END DO
+         END DO
+      END DO
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem3')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
 
       DO jk = 1, jpkm1
@@ -194,5 +252,9 @@
                zsiremin = xsirem * zstep * znusil
 #    endif
-               osil(ji,jj,jk) = zsiremin * trn(ji,jj,jk,jpdsi)
+               zosil = zsiremin * trn(ji,jj,jk,jpdsi)
+
+               tra(ji,jj,jk,jpdsi) = tra(ji,jj,jk,jpdsi) - zosil
+               tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + zosil
+
                !
             END DO
@@ -200,9 +262,32 @@
       END DO
 
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem4')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
       zfesatur(:,:,:) = 0.6e-9
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
+!CDIR NOVERRCHK
+      DO jk = 1, jpkm1
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
+            DO ji = 1, jpi
+!
+!      Compute de different ratios for scavenging of iron
+!      --------------------------------------------------
+
+#if  defined key_kriest
+               zdenom1 = trn(ji,jj,jk,jppoc) / &
+           &           ( trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
+#else
+                zdenom = 1. / ( trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpgoc)  &
+           &            + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
+
+                zdenom1 = trn(ji,jj,jk,jppoc) * zdenom
+                zdenom2 = trn(ji,jj,jk,jpgoc) * zdenom
+#endif
+
 
 !     scavenging rate of iron. this scavenging rate depends on the
@@ -222,7 +307,7 @@
 #endif
 # if defined key_off_degrad
-               xscave(ji,jj,jk) = zfeequi * zlam1b * zstep  * facvol(ji,jj,jk)
+               zscave = zfeequi * zlam1b * zstep  * facvol(ji,jj,jk)
 # else
-               xscave(ji,jj,jk) = zfeequi * zlam1b * zstep
+               zscave = zfeequi * zlam1b * zstep
 # endif
 
@@ -236,22 +321,58 @@
                zlam1b = (  80.* ( trn(ji,jj,jk,jpdoc) + 35.e-6 )                           &
                   &     + 698.*   trn(ji,jj,jk,jppoc) + 1.05e4 * trn(ji,jj,jk,jpgoc)  )                    &
-                  &   * zdiss(ji,jj,jk) + 1E-4 * (1.-zlamfac)                &
+                  &   * xdiss(ji,jj,jk) + 1E-4 * (1.-zlamfac)                &
                   &   + xlam1 * MAX( 0.e0, ( trn(ji,jj,jk,jpfer) * 1.e9 - 1.)  )
 #else
                zlam1b = (  80.* (trn(ji,jj,jk,jpdoc) + 35E-6)           &
                   &     + 698.*  trn(ji,jj,jk,jppoc)  )                    &
-                  &   * zdiss(ji,jj,jk) + 1E-4 * (1.-zlamfac)           &
+                  &   * xdiss(ji,jj,jk) + 1E-4 * (1.-zlamfac)           &
                   &   + xlam1 * MAX( 0.e0, ( trn(ji,jj,jk,jpfer) * 1.e9 - 1.)  )
 #endif
 
 # if defined key_off_degrad
-               xaggdfe(ji,jj,jk) = zlam1b * zstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi ) * facvol(ji,jj,jk)
+               zaggdfe = zlam1b * zstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi ) * facvol(ji,jj,jk)
 # else
-               xaggdfe(ji,jj,jk) = zlam1b * zstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi )
-# endif
+               zaggdfe = zlam1b * zstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi )
+# endif
+
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zscave - zaggdfe
+
+#if defined key_kriest
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * zdenom1
+#else
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * zdenom1
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * zdenom2
+#endif
+
             END DO
          END DO
       END DO
       !
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem5')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
+!     Update the arrays TRA which contain the biological sources and sinks
+!     --------------------------------------------------------------------
+
+      DO jk = 1, jpkm1
+         tra(:,:,jk,jppo4) = tra(:,:,jk,jppo4) + zolimi(:,:,jk) + denitr(:,:,jk)
+         tra(:,:,jk,jpnh4) = tra(:,:,jk,jpnh4) + zolimi(:,:,jk) + denitr(:,:,jk)
+         tra(:,:,jk,jpno3) = tra(:,:,jk,jpno3) - denitr(:,:,jk) * rdenit
+         tra(:,:,jk,jpdoc) = tra(:,:,jk,jpdoc) - zolimi(:,:,jk) - denitr(:,:,jk)
+         tra(:,:,jk,jpoxy) = tra(:,:,jk,jpoxy) - zolimi(:,:,jk) * o2ut
+         tra(:,:,jk,jpdic) = tra(:,:,jk,jpdic) + zolimi(:,:,jk) + denitr(:,:,jk)
+         tra(:,:,jk,jptal) = tra(:,:,jk,jptal) + denitr(:,:,jk) * rno3 * rdenit
+     END DO
+
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('rem6')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_rem
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 858)
@@ -17,4 +17,6 @@
    USE sms
    USE lib_mpp
+   USE prtctl_trc
+
 
    IMPLICIT NONE
@@ -50,4 +52,5 @@
       REAL(wp), DIMENSION(jpi,jpj)     ::   zsidep
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znitrpot, zirondep
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
@@ -221,5 +224,5 @@
             DO ji = 2, jpim1
                zdenitot = zdenitot + denitr(ji,jj,jk) * rdenit * e1t(ji,jj) * e2t(ji,jj)   &
-                  &    *fse3t(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj) * znegtr(ji,jj,jk)
+                  &    *fse3t(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj) * xnegtr(ji,jj,jk)
             END DO
          END DO
@@ -231,6 +234,9 @@
       ! -------------------------------------------------------------
 
+!CDIR NOVERRCHK
       DO jk = 1, jpk
-         DO jj = 1, jpj
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
             DO ji = 1, jpi
                zlim = ( 1.- xnanono3(ji,jj,jk) - xnanonh4(ji,jj,jk) )
@@ -265,5 +271,6 @@
             DO ji = 1, jpi
 # if ! defined key_cfg_1d && ( defined key_orca_r4 || defined key_orca_r2 || defined key_orca_r05 || defined key_orca_r025 )
-               zfact = znitrpot(ji,jj,jk) * zdenitot / znitrpottot
+!!               zfact = znitrpot(ji,jj,jk) * zdenitot / znitrpottot
+               zfact = znitrpot(ji,jj,jk) * 1.e-7
 # else
                zfact = znitrpot(ji,jj,jk) * 1.e-7
@@ -285,4 +292,10 @@
 # endif
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('sed ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=trn, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_sed
 
